#include <iostream>

using namespace std;

int main()
{ int i, j, k, m, n, c, *a, *b, ck=998244353;
  long long sum;

  cin>>n>>m;
  a = new int[n+1];
  b = new int[m+1];
  for(i=1;i<=n;i++) a[i]=i;
  for(i=1;i<=m;i++) cin>>b[i];
  cin>>c;
  for(i=0;i<=n-m;i++)
     for(j=1;j<=m;j++) a[i+b[j]]=a[i+j];
  sum=0;
  for(i=n;i>0;i--)
    { sum=(sum+a[i])*c;
      if(sum>=ck) sum = sum%ck;
    }
  cout << sum;
  return 0;
}